<?php

namespace app\index\controller;
use think\Controller;
use think\Db;
use think\Request;
class  TbEiact extends Controller
{
public function index()
{
$edate=date("Y-m-d");
$sdate=date('Y-m-d',strtotime("$edate -1 month"));
if (!empty($_GET['stime'])) {
$sdate=$_GET['stime'];
}
if (!empty($_GET['etime'])) {
$edate=substr($_GET['etime'],0,10);
$edate=date("Y-m-d",strtotime("$edate +1 day"));
}
if (empty($_GET['id'])) die('无效的编号');
$id = $_GET['id'];
$warn=Db::table('warn_cfg')->where('eqmid',$id)->find();
session('warn',$warn);
$this->assign('warn',$warn);
$data = Db::table('data_eia_h')->field('d_time,d_ct_1')->where('eqmid',$id)->where('d_time','between time',[$sdate,$edate])->order('d_time desc')->paginate(10,false,['query'=>request()->param(),]);
$data1 = Db::table('data_eia_h')->field('d_time,d_ct_1')->where('eqmid',$id)->where('d_time','between time',[$sdate,$edate])->select();
session('data',$data);
session('data1',$data1);
$this->assign('data',$data);
return $this->fetch('tb_eiact');
}
public function ExcelOne()
{
$list = session('data');
$xlsCell  = array(
array('d_time','时间'),
array('d_ct_1','泄露电流')        
);
$this->exportExcel("当前数据导出",$xlsCell,$list);
}
public function ExcelAll()
{
$list = session('data1');
$xlsCell  = array(
array('d_time','时间'),
array('d_ct_1','泄露电流')        
);
$this->exportExcel("全部数据导出",$xlsCell,$list);
}
public function exportExcel($expTitle,$expCellName,$expTableData)
{
$xlsTitle = iconv('utf-8','gb2312',$expTitle);
$fileName = $expTitle.date('_YmdHis');
$cellNum = count($expCellName);
$dataNum = count($expTableData);
import('PhpExcel',EXTEND_PATH);
$objPHPExcel = new \PhpExcel();
$objWriter = new \PHPExcel_Writer_Excel5($objPHPExcel);
$cellName = array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','AA','AB','AC','AD','AE','AF','AG','AH','AI','AJ','AK','AL','AM','AN','AO','AP','AQ','AR','AS','AT','AU','AV','AW','AX','AY','AZ');
$objPHPExcel->getActiveSheet(0)->mergeCells('A1:'.$cellName[$cellNum-1].'1');
for($i=0;$i<$cellNum;$i++){
$objPHPExcel->getActiveSheet(0)->getColumnDimension($cellName[$i])->setWidth(18);
$objPHPExcel->setActiveSheetIndex(0)->setCellValue($cellName[$i].'2',$expCellName[$i][1]);
}
for($i=0;$i<$dataNum;$i++){
for($j=0;$j<$cellNum;$j++){
if($expTableData[$i]['d_ct_1']<session('warn.warnmin5') ||$expTableData[$i]['d_ct_1']>session('warn.warnmax5')){
$objPHPExcel->getActiveSheet(0)->getStyle('B'.($i+3))->getFont()->getColor()->setARGB('FFFF0000');
}
$objPHPExcel->getActiveSheet(0)->setCellValue($cellName[$j].($i+3),$expTableData[$i][$expCellName[$j][0]]);
}
}
header('Content-Type: application/vnd.ms-excel');
header('Content-Disposition: attachment;filename="'.$xlsTitle.'.xls"');
header('Cache-Control: max-age=0');
$objWriter->save('php://output');
exit;
}
}
?>